/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 10.10.2010
Author  : 
Company : 
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <spi.h>
#include <string.h>
#include <stdio.h>

#include <ds1307_twi.h>
#include <bcd.h>
#include <lcd.c>

#define delay_   30           //  
#define TRIAC_PIN PORTD.4     //   

#define power_x   25          //    
#define power_y   40          //  

int status = 0;               //   

unsigned int tick = 0;        //  
unsigned char b_cnt = 0;      //  
bit start_cond = 0;           //  

volatile unsigned char addr_1 = 0;     //  
volatile unsigned char addr_0 = 0;     //  
volatile unsigned char cmd_1 = 0;      //  
volatile unsigned char cmd_0 = 0;      //  
volatile unsigned char cmd = 0;        // 

unsigned char hour,min,sec; //, , 
unsigned char day,month,year; //, , 

char cnt[];  //     sprint()

long int count_RTC = 0;

//   
//char txt1[]="19:42";

//    16- 
flash const unsigned int nagruzka[99] = {
20324,  // 1% 
19794,  // 2% 
19384,  // 3% 
19036,18728,18450,18190,17948,17720,17504,17296,17096,16904,16718,16536,16360,16188,16022,15858,15696,
15538,15384,15232,15082,14934,14788,14644,14500,14360,14220,14082,13944,13808,13674,13540,13406,13274,13142,
13012,12882,12752,12622,12494,12366,12238,12110,11982,11854,11728,11600,11472,11346,11218,11090,10962,10834,
10706,10578,10448,10318,10188,10058,9926,9794,9660,9526,9392,9256,9118,8980,8840,8700,8556,8412,8266,8118,
7968,7816,7662,7504,7342,7178,7012,6840,6664,6482,6296,6104,5904,5696,5480,5252,5010,4750,4472,4164,
3816, // 97% 
3406, // 98% 
2876  // 99% 
};

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
  {
  OCR1A = nagruzka[status];
  OCR1B = nagruzka[status]+60;
  TCNT1 = 0;      //  
  //GICR| = 0x80; //   INT0 // GIFR = 0x10000000
  GICR&=~(1<<6);  //   INT0 // GIFR = 0x10000000
  }
  
// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
        TCNT0=0xFA;                                                             //    96 
        TCCR0=0x04;                                                             //   62.500 
        
        if (tick >= 90 && tick < 98)                                            //   8,64   9,408 
                {
                start_cond = 1;                                                 //  
                addr_1 = addr_0 = cmd_1 = cmd_0 = 0;                            //     
                }
        if (tick >= 20 && tick < 27 && start_cond)                              //   1,92   2,592 
                {
                b_cnt++;                                                        // "1"    
                if (b_cnt < 9) addr_1 = (addr_1 << 1) + 1;                      //  -  
                if (b_cnt >= 9 && b_cnt < 17) addr_0 = (addr_0 << 1) + 1;       //  -  
                if (b_cnt >= 16 && b_cnt < 25) cmd_1 = (cmd_1 << 1) + 1;        //  -  
                if (b_cnt >= 24) cmd_0 = (cmd_0 << 1) + 1;                      //  -  
                }
        if (tick >= 9 && tick < 16 && start_cond)                               //   0,864   1,536 
                {
                b_cnt++;                                                        // "0"    
                if (b_cnt < 9) addr_1 = (addr_1 << 1);                          // -   
                if (b_cnt >= 9 && b_cnt < 17) addr_0 = (addr_0 << 1);
                if (b_cnt >= 16 && b_cnt < 25) cmd_1 = (cmd_1 << 1);
                if (b_cnt >= 24) cmd_0 = (cmd_0 << 1);
                }
        tick = 0;                                                               // 
        if (b_cnt == 32)                                                        //   4 
                {
//              if ((addr_1+addr_0) == 0xFF) addr = addr_0;                     //,     
//              else addr = 0;                                                  //  
                if ((cmd_1 + cmd_0) == 0xFF) {                                  //   
                  cmd = cmd_1;
                  b_cnt = 0;                                                    //  
                  start_cond = 0;                                               //  
                  }                       
                else {
                  cmd = 0;        
                  b_cnt = 0;                                                    //  
                  start_cond = 0;                                               //  
                  TCCR0=0x00;                                                   // 
                  TCNT0=0x00;
                  }
                }
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
        TCNT0=0xFA;                                                    //  -  96 
        tick++;                                                        //  
        if (tick > 500) {                                              //   48 
          TCCR0=0x00;                                                  //    
          TCNT0=0x00;
          tick = 0;                                                       
          start_cond = 0;
          cmd = 0;
        }
}

// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
  { 
  TRIAC_PIN = 0;    //  
  }
  
// Timer 1 output compare B interrupt service routine
interrupt [TIM1_COMPB] void timer1_compb_isr(void)
{
 TRIAC_PIN = 1;    //    
 GIFR|=(1<<6);     //    -   
 GICR|=(1<<6);     //   INT0.
}

/*=========================================    ===========================================*/

void soft_on () {
 TCCR1B=0x02;                                           
 while (status<98) {
  status++;            
  delay_ms(delay_);
  sprintf(cnt,"%u",status);                     //  ""  
  put_string(power_x, power_y,cnt, 0x07E0, 3);  //   
 };
 status = 98;
 TCCR1B=0x00;                
 TRIAC_PIN = 0;                                 //   
}

/*==============================       ===================================*/

void soft_off () {
  TCCR1B=0x02;                      
  while (status>0) {
   status--;
   delay_ms(delay_);
   sprintf(cnt,"%u",status);                     //  ""  
   put_string(power_x, power_y,cnt, 0x07E0, 3);  //   
  }
  status = 0;
  TCCR1B=0x00;                 
  TRIAC_PIN = 1;                                 //                
}

/*===========================================   DS1307 ============================================*/

void DS1307_on () {
  unsigned char tmp;
  tmp = rtc_read(0x00);
  tmp &=~(1<<7);
  rtc_write(0x00, tmp);   // DS1307,  7 
  tmp = rtc_read(0x02);
  tmp &=~(1<<6);
  rtc_write(0x02, tmp);   //  6  - 24  
}

void main(void)
{
// Input/Output Ports initialization
// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func6=Out Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=0 State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0x4F;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=1 State3=P State2=P State1=T State0=T 
PORTD=0x1C;
DDRD=0x10;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 2000,000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: On
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: On
// INT1 Mode: Falling Edge
GICR|=0xC0;
MCUCR=0x0A;
GIFR=0xC0;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x19;     

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2*4000,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x01;

// 2 Wire Bus initialization
// Generate Acknowledge Pulse: On
// 2 Wire Bus Slave Address: 68h
// General Call Recognition: Off
// Bit Rate: 100,000 kHz

TWSR=0x00;
TWBR=0x48;
TWAR=0xD0;
TWCR=0x44;

// Global enable interrupts
#asm("sei")

LCD_init();
fill_screen(bgcolor);


//rtc_write(0x02,rtc_read(0x02)&~0x40);    //  24   ( 6  002  0)
//rtc_write(0x00,rtc_read(0x00)&~0x80);   //   ( 7  000  0)
DS1307_on ();
rtc_init (0,0,0);
//rtc_set_time (bin2bcd(20),bin2bcd(47),bin2bcd(12));
//rtc_set_date (bin2bcd(17),bin2bcd(03),bin2bcd(11));

//put_string(50, 0,txt1, 0xF800, 2);

sprintf(cnt,"%u",status);                     //  ""  
put_string(power_x, power_y,cnt, 0x07E0, 3);  //   

while (1)
      { count_RTC++;    
/*======================================      ==================================*/

      /*if (PINB.0==0) {         //    
       delay_ms(50);           // 
       if (status==0) {
        TCCR1B=0x02;           //    2000 
        soft_on (98);          //   1%  99% 
        TCCR1B=0x00;           //   (      200    PORTC.5 )
        PORTC.5 = 1;           // 100%
		status = 98;
        }
       else {
        TCCR1B=0x02;
        soft_off(status);      //     
        TCCR1B=0x00;
        PORTC.5 = 0; // 0%
        status=0;
       };
       }*/
       
       /*if (PINB.5==0) {      // /  
       //  /
       }*/
       
/*========================================= /  =======================================*/

	   if (cmd == 0b11111000) {                           //  "Display" -  
          TCCR1B=0x02;
		  status++;
		  if (status > 97) {
            TCCR1B=0x00;
		    status = 98;   
            TRIAC_PIN = 0;                                //  
            sprintf(cnt,"%u",status);                     //  ""  
            put_string(power_x, power_y,cnt, 0x07E0, 3);  //   
			}
          else {
            sprintf(cnt,"%u",status);                     //  ""  
            put_string(power_x, power_y,cnt, 0x07E0, 3);  //   
		    delay_ms(delay_);
            }
		 }
         
       if (cmd == 0b11000000) {                           //  "Sleep" -  
          TCCR1B=0x02;
		  status--;
		  if (status < 1) {
		    status = 0;                                   //     
            TCCR1B=0x00;
            TRIAC_PIN = 1;                                //  
            sprintf(cnt,"%u",status);                     //  ""  
            put_string(power_x, power_y,cnt, 0x07E0, 3);  //   
			}
          else {
            sprintf(cnt,"%u",status);                     //  ""  
            put_string(power_x, power_y,cnt, 0x07E0, 3);  //   
		    delay_ms(delay_);
            }
		 }
         
/*===================================== /   ========================================*/

      if (cmd == 0b11011000) {        //  "TV" - / 
       GICR&=~(1<<7);                 //   INT1 ( TSOP) // GIFR = 0x01000000
       if (status == 0) {
        soft_on ();                   // 100% 
        }
       else {
        soft_off();                  //   
       };
       GIFR|=(1<<7);                 //    -   
       GICR|=(1<<7);                 //   INT1
      }
      
      if (cmd == 0b10000000) {       //  "VIDEO" - /  
      //  /
      LCD_PowerOff ();
      }
      
      if (count_RTC > 100000) {          //    DS1307  
        count_RTC = 0;
        rtc_get_time(&hour,&min,&sec);   // 
        rtc_get_date(&day,&month,&year); // 
      
        sec = bcd2bin(sec);
        min = bcd2bin(min);
        hour = bcd2bin(hour);
        day = bcd2bin(day);
        month = bcd2bin(month);
        year = bcd2bin(year);

        sprintf(cnt,"%02u:%02u:%02u",hour,min,sec);
        put_string(10, 10,cnt, 0x07E0, 1);
        sprintf(cnt,"%02u.%02u.20%02u",day,month,year);        
        put_string(10, 100,cnt, 0x07E0, 1);  
        }
      };     
}
